Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.expr
Class AxisExpression

    java.lang.Object
      net.sf.saxon.expr.Expression
          net.sf.saxon.expr.AxisExpression

All Implemented Interfaces:
  Serializable, SourceLocator, Container, EvaluableItem, SequenceIterable, InstructionInfoProvider

    public final class AxisExpression

extends Expression

An AxisExpression is always obtained by simplifying a PathExpression. It represents a PathExpression that starts at the context node, and uses a simple node-test with no filters. For example "*", "title", "./item", "@*", or "ancestor::chapter*".

An AxisExpression delivers nodes in axis order (not in document order). To get nodes in document order, in the case of a reverse axis, the expression should be wrapped in a Reverser.

See Also:
  Serialized Form

Field Summary

Fields inherited from class net.sf.saxon.expr.Expression
`EVALUATE_METHOD, ITERATE_METHOD, PROCESS_METHOD`

Constructor Summary
`AxisExpression(byte axis, NodeTest nodeTest)` Constructor

Method Summary
`int` | `computeCardinality()` Specify that the expression returns a singleton
`int` | `computeSpecialProperties()` Get the static properties of this expression (other than its type).
`void` | `display(int level, PrintStream out, Configuration config)` Diagnostic print of expression structure
`boolean` | `equals(Object other)` Is this expression the same as another expression?
`byte` | `getAxis()` Get the axis
`ItemType` | `getContextItemType()` Get the static type of the context item for this AxisExpression.
`int` | `getIntrinsicDependencies()` Determine which aspects of the context the expression depends on.
`ItemType` | `getItemType(TypeHierarchy th)` Determine the data type of the items returned by this expression
`NodeTest` | `getNodeTest()` Get the NodeTest.
`int` | `hashCode()` get HashCode for comparing two expressions
`SequenceIterator` | `iterate(XPathContext context)` Evaluate the path-expression in a given context to return a NodeSet
`Expression` | `optimize(Optimizer opt, StaticContext env, ItemType contextItemType)` Perform optimisation of an expression and its subexpressions.
`Expression` | `simplify(StaticContext env)` Simplify an expression
`String` | `toString()` Represent the expression as a string for diagnostics
`String` | `toString(NamePool pool)` Represent the expression as a string for diagnostics
`Expression` | `typeCheck(StaticContext env, ItemType contextItemType)` Type-check the expression

Methods inherited from class net.sf.saxon.expr.Expression
`adoptChildExpression, checkPermittedContents, computeDependencies, computeStaticProperties, doPromotion, effectiveBooleanValue, evaluateAsString, evaluateItem, getCardinality, getColumnNumber, getContainingProcedure, getDependencies, getExecutable, getHostLanguage, getImplementationMethod, getInstructionInfo, getLineNumber, getLocationId, getLocationProvider, getParentExpression, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, hasBadParentPointer, iterateSubExpressions, markTailFunctionCalls, process, promote, replaceSubExpression, resetStaticProperties, setLocationId, setParentExpression, setParentExpression, suppressValidation`

Methods inherited from class java.lang.Object
`getClass, notify, notifyAll, wait, wait, wait`

Constructor Detail

### AxisExpression

    public AxisExpression(byte axis,
                          NodeTest nodeTest)

  Constructor

  Parameters:
    `axis` - The axis to be used in this AxisExpression: relevant constants are defined in class net.sf.saxon.om.Axis.
    `nodeTest` - The conditions to be satisfied by selected nodes. May be null, indicating that any node on the axis is acceptable
  See Also:
    `Axis`

Method Detail

### simplify

    public Expression simplify(StaticContext env)

  Simplify an expression

  Overrides:
    `simplify` in class `Expression`
  Returns:
    the simplified expression

### typeCheck

    public Expression typeCheck(StaticContext env,
                                ItemType contextItemType)
                         throws XPathException

  Type-check the expression

  Overrides:
    `typeCheck` in class `Expression`
  Parameters:
    `env` - the static context of the expression
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
  Throws:
    `StaticError` - if an error is discovered during this phase (typically a type error)
    `XPathException`

### getContextItemType

    public ItemType getContextItemType()

  Get the static type of the context item for this AxisExpression. May be null if not known.

### optimize

    public Expression optimize(Optimizer opt,
                               StaticContext env,
                               ItemType contextItemType)

  Perform optimisation of an expression and its subexpressions.

  This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

  Overrides:
    `optimize` in class `Expression`
  Parameters:
    `opt` - the optimizer in use. This provides access to supporting functions; it also allows different optimization strategies to be used in different circumstances.
    `env` - the static context of the expression
    `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
  Returns:
    the original expression, rewritten if appropriate to optimize execution

### equals

    public boolean equals(Object other)

  Is this expression the same as another expression?

  Overrides:
    `equals` in class `Object`

### hashCode

    public int hashCode()

  get HashCode for comparing two expressions

  Overrides:
    `hashCode` in class `Object`

### getIntrinsicDependencies

    public int getIntrinsicDependencies()

  Determine which aspects of the context the expression depends on. The result is a bitwise-or'ed value composed from constants such as XPathContext.VARIABLES and XPathContext.CURRENT_NODE

  Overrides:
    `getIntrinsicDependencies` in class `Expression`
  Returns:
    a set of bit-significant flags identifying the "intrinsic" dependencies. The flags are documented in class net.sf.saxon.value.StaticProperty

### computeSpecialProperties

    public int computeSpecialProperties()

  Get the static properties of this expression (other than its type). The result is bit-signficant. These properties are used for optimizations. In general, if property bit is set, it is true, but if it is unset, the value is unknown.

  Overrides:
    `computeSpecialProperties` in class `Expression`

### getItemType

    public final ItemType getItemType(TypeHierarchy th)

  Determine the data type of the items returned by this expression

  Specified by:
    `getItemType` in class `Expression`
  Parameters:
    `th` -
  Returns:
    Type.NODE or a subtype, based on the NodeTest in the axis step, plus information about the content type if this is known from schema analysis

### computeCardinality

    public final int computeCardinality()

  Specify that the expression returns a singleton

### getAxis

    public byte getAxis()

  Get the axis

### getNodeTest

    public NodeTest getNodeTest()

  Get the NodeTest. Returns null if the AxisExpression can return any node.

### iterate

    public SequenceIterator iterate(XPathContext context)
                             throws XPathException

  Evaluate the path-expression in a given context to return a NodeSet

  Specified by:
    `iterate` in interface `SequenceIterable`
  Overrides:
    `iterate` in class `Expression`
  Parameters:
    `context` - the evaluation context
  Returns:
    a SequenceIterator that can be used to iterate over the result of the expression
  Throws:
    `XPathException` - if any dynamic error occurs evaluating the expression

### display

    public void display(int level,
                        PrintStream out,
                        Configuration config)

  Diagnostic print of expression structure

  Specified by:
    `display` in class `Expression`
  Parameters:
    `level` - indentation level for this expression
    `out` - Output destination

### toString

    public String toString()

  Represent the expression as a string for diagnostics

  Overrides:
    `toString` in class `Object`

### toString

    public String toString(NamePool pool)

  Represent the expression as a string for diagnostics

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.